package edu.uiuc.edsg.test;

import org.junit.*;

import edu.uiuc.edsg.*;

public class CombinatoricLinkTest {
	
	@Test()
	public void testIteration() {
		IGenerator<String> gen1 = new Chain<String>("string1", "string2", "string3");
		IGenerator<Integer> gen2 = new Chain<Integer>(1, 2, 3, 4);
		
		CombinatoricLink link = new CombinatoricLink(new GeneratorLink(gen1), new GeneratorLink(gen2));
		
		LinkTestUtil.iterateLink(link, 3*4, gen1, gen2);
	}
	
	@Test()
	public void testNestedIteration() {
		IGenerator<String> gen1 = new Chain<String>("string1", "string2");
		IGenerator<Integer> gen2 = new Chain<Integer>(1, 2, 3);
		IGenerator<Character> gen3 = new Chain<Character>('a', 'b', 'c', 'd');
		
		CombinatoricLink link = 
			new CombinatoricLink(
					new GeneratorLink(gen1), 
					new CombinatoricLink(
							new GeneratorLink(gen2),
							new GeneratorLink(gen3)));
		
		LinkTestUtil.iterateLink(link, 2 * 3 * 4, gen1, gen2, gen3);
	}
	
	@Test()
	public void testDeepNesting() {
		CombinatoricLink link = 
			new CombinatoricLink(
					new CombinatoricLink(
							new CombinatoricLink(
									new GeneratorLink(new Chain<String>("1", "2")), 
									new CombinatoricLink(
											new GeneratorLink(new Chain<String>("3", "4")), 
											new GeneratorLink(new Chain<String>("5", "6")))),
							new GeneratorLink(new Chain<String>("7", "8"))),
					new GeneratorLink(new Chain<String>("9", "10")));
		
		LinkTestUtil.iterateLink(link, 2 * 2 * 2 * 2 * 2);
	}
}
