package edu.uiuc.edsg.test;

import org.junit.*;

import edu.uiuc.edsg.*;

public class RepeaterTest {

	@Test() 
	public void testBasicFunctionality() {
		Chain<Integer> baseGen = new Chain<Integer>(1, 2, 3);
		Repeater<Integer> repeater = new Repeater<Integer>(baseGen, 5);
		GeneratorTestUtil.testBasicFunctionality(repeater, 3 * 5); // repeat a list of three items five times
	}
	
	@Test(expected=IllegalArgumentException.class)
	public void zeroRepetitions() {
		Chain<Integer> baseGen = new Chain<Integer>(1, 2, 3);
		new Repeater<Integer>(baseGen, 0); // illegal repetitions
	}
	
	@Test()
	public void oneRepetition() {
		Chain<Integer> baseGen = new Chain<Integer>(1, 2, 3);
		Repeater<Integer> repeater = new Repeater<Integer>(baseGen, 1); // one repetition
		GeneratorTestUtil.testBasicFunctionality(repeater, 3);		
	}

}
