package edu.uiuc.edsg.test.samples;


import org.junit.*;

import edu.uiuc.edsg.*;
import edu.uiuc.edsg.samples.Graph;
import edu.uiuc.edsg.samples.GraphGenerator;

public class GraphGeneratorTest {

	@Test 
	public void threeNodes() {
		// generate all graphs with three nodes
		GraphGenerator<String> graphGen = new GraphGenerator<String>(
				new Literal<String>("1"), 
				new Literal<String>("2"), 
				new Literal<String>("3"));
		
		int i = 0;
		for (Graph g : graphGen) {
			Assert.assertEquals("Graph must have three nodes", g.nodeCount(), 3);
			
			// print for demo
			System.out.println("GRAPH #" + ++i);
			System.out.print(g);
		}
		
		Assert.assertEquals("Wrong number of graphs generated", 512, i);		
	}

}
