package edu.uiuc.edsg.test.samples;


import org.junit.*;

import edu.uiuc.edsg.*;
import edu.uiuc.edsg.samples.List;
import edu.uiuc.edsg.samples.ListGenerator;
import edu.uiuc.edsg.samples.ListGenerator.ValueGenCallback;

public class ListGeneratorTest {
	
	@Test
	public void exhaustiveListDemo() {

		// generator for list
		ListGenerator<Integer> listGen = 
			new ListGenerator<Integer>(
				new ValueGenCallback<Integer>() {
					public IGenerator<Integer> newValueGenerator() {
						return new Chain<Integer>(0, 1, 2);
					}
				},
				4);
		
		// display results		
		int count = 0;
		for (List list : listGen) {
			System.out.println(list.toString());
			count++;
		}
		// all combinations up to length 4
		Assert.assertEquals(3 + 3 * 3 + 3 * 3 * 3 + 3 * 3 * 3 * 3, count);
	}
	
	@Test
	public void arbitraryListDemo() {		
		// generator for list
		ListGenerator<Integer> listGen = 
			new ListGenerator<Integer>(
					new ValueGenCallback<Integer>() {
						public IGenerator<Integer> newValueGenerator() {
							return new Choose<Integer>(0, 1, 2);
						}
					}, 10);
		
		// display results
		int count = 0;
		for (List list : listGen) {
			System.out.println(list.toString());
			count++;
		}
		Assert.assertEquals(10, count);
		
	}

}
