package edu.uiuc.astgen;

import edu.uiuc.edsg.*;

public class ASTNodeChain<ASTNodeType extends org.eclipse.jdt.core.dom.ASTNode>
		extends ASTNodeGeneratorBase<ASTNodeType> {

	private Chain<ASTNodeType> _innerSequence;
	
	public ASTNodeChain() {
		super();
		_innerSequence = new Chain<ASTNodeType>();
	}
	
	public ASTNodeChain(ASTNodeType... values) {
		this();
		for (ASTNodeType value : values) {
			add(value);
		}
	}
	
	public ASTNodeChain(ASTNodeGeneratorBase<ASTNodeType>... generators) {
		this();
		for (ASTNodeGeneratorBase<ASTNodeType> gen : generators) {
			add(gen);
		}
	}
	
	public <GeneratorType extends ASTNodeGeneratorBase<ASTNodeType>> void add(GeneratorType generator) {
		_innerSequence.add(generator);
	}
	
	public void add(ASTNodeType node) {
		_innerSequence.add(node);
	}

	@Override
	protected IIterationLink getInitializedIterator() {
		return new GeneratorLink(_innerSequence);
	}
	
	@Override
	protected ASTNodeType generateCurrent() {
		return _innerSequence.current();
	}
	
	
}
