package edu.uiuc.astgen.basic;

import org.eclipse.jdt.core.dom.*;

import edu.uiuc.astgen.ASTNodeGeneratorBase;
import edu.uiuc.edsg.GeneratorLink;
import edu.uiuc.edsg.IIterationLink;

public class PackageDeclarationGenerator extends
		ASTNodeGeneratorBase<PackageDeclaration> {

	private ASTNodeGeneratorBase<? extends Name> _nameGen;
	
	public PackageDeclarationGenerator(ASTNodeGeneratorBase<? extends Name> nameGen) {
		super();
		_nameGen = nameGen;
	}
	
	@Override
	protected IIterationLink getInitializedIterator() {
		return new GeneratorLink(_nameGen);
	}
	
	@Override
	protected PackageDeclaration generateCurrent() {
		PackageDeclaration pd = super.getAST().newPackageDeclaration();
		pd.setName(_nameGen.current());
		
		return pd;
	}
}
