package edu.uiuc.astgen.basic;

import org.eclipse.jdt.core.dom.BooleanLiteral;
import org.eclipse.jdt.core.dom.Expression;
import org.eclipse.jdt.core.dom.ParenthesizedExpression;

import edu.uiuc.astgen.ASTNodeGeneratorBase;
import edu.uiuc.edsg.GeneratorLink;
import edu.uiuc.edsg.IIterationLink;

public class ParenthesizedExpressionGenerator extends ASTNodeGeneratorBase<ParenthesizedExpression>{
	private ASTNodeGeneratorBase<? extends Expression> expressionDeclaration;	
	
	public ParenthesizedExpressionGenerator(
			ASTNodeGeneratorBase<? extends Expression> expressionGen) {
		super();
		expressionDeclaration = expressionGen;
	}

	@Override
	protected IIterationLink getInitializedIterator() {
		return new GeneratorLink(expressionDeclaration);
	}
	
	@Override
	protected ParenthesizedExpression generateCurrent() {	
		ParenthesizedExpression parenthesizedExpression = super.getAST().newParenthesizedExpression();		
		parenthesizedExpression.setExpression(expressionDeclaration.current());
		return parenthesizedExpression;
	}
}
