package edu.uiuc.astgen.basic;

import org.eclipse.jdt.core.dom.*;

import edu.uiuc.astgen.ASTNodeGeneratorBase;
import edu.uiuc.edsg.*;

/**
 * Generates SimpleName nodes
 */
public class SimpleNameGenerator extends ASTNodeGeneratorBase<SimpleName> {

	private IGenerator<String> _nameGenerator;
	
	public SimpleNameGenerator(String name) {
		this(new Literal<String>(name));
	}
	
	public SimpleNameGenerator(IGenerator<String> nameGenerator) {
		super();
		_nameGenerator = nameGenerator;
	}
	
	@Override
	protected IIterationLink getInitializedIterator() {	
		return new GeneratorLink(_nameGenerator);
	}

	@Override
	protected SimpleName generateCurrent() {
		return super.getAST().newSimpleName(_nameGenerator.current());
	}
}
