package edu.uiuc.astgen.basic;

import org.eclipse.jdt.core.dom.Expression;
import org.eclipse.jdt.core.dom.ThrowStatement;
import edu.uiuc.astgen.ASTNodeGeneratorBase;
import edu.uiuc.edsg.IGenerator;
import edu.uiuc.edsg.IIterationLink;
import edu.uiuc.edsg.LinkCreator;
import edu.uiuc.edsg.test.GeneratorTestUtil;

public class ThrowStatementGenerator extends ASTNodeGeneratorBase<ThrowStatement>{
	private IGenerator<? extends Expression> expressionDeclaration;
	
	public ThrowStatementGenerator (ASTNodeGeneratorBase<? extends Expression> expressionGen) {
		super();
		expressionDeclaration = expressionGen;
	}

	@Override
	protected ThrowStatement generateCurrent() {
		ThrowStatement throwStatement = super.getAST().newThrowStatement();
		throwStatement.setExpression(expressionDeclaration.current());
		return throwStatement;	
	}

	@Override
	protected IIterationLink getInitializedIterator() {
		LinkCreator linkCreator = new LinkCreator(LinkCreator.LinkType.COMBINATORIC);
		linkCreator.add(expressionDeclaration);
		return linkCreator.getLink();
	}
	
	public static ThrowStatementGenerator getNewDefaultThrowStatementGenerator(){
		ClassInstanceCreationGenerator classInstanceCreationGen = ClassInstanceCreationGenerator.getNewDefaultClassInstanceCreationGenerator();
		ThrowStatementGenerator throwStatementGen = new ThrowStatementGenerator(classInstanceCreationGen);
		GeneratorTestUtil.testBasicFunctionality(throwStatementGen, 3);		
		return throwStatementGen;
	}

}
