package edu.uiuc.astgen.methodrelationships;

import edu.uiuc.edsg.Chain;
import edu.uiuc.edsg.CompositeGenerator;
import edu.uiuc.edsg.GeneratorLink;
import edu.uiuc.edsg.IGenerator;
import edu.uiuc.edsg.IIterationLink;

public class StatementInBlockBuilderGenerator extends
		CompositeGenerator<StatementInBlockBuilder> {
	
	private Chain<StatementInBlockBuilder> builderChain;
	
	@Override
	protected IIterationLink getInitializedIterator() {
		if (builderChain == null) {
			builderChain = new Chain<StatementInBlockBuilder>(
					new InBlockBuilder(),
					new InSubBlockBuilder(),
					new InLocalClassBuilder());
		}
		return new GeneratorLink(builderChain);		
	}

	@Override
	protected StatementInBlockBuilder generateCurrent() {
		return builderChain.current();
	}

}
