package edu.uiuc.astgen.statements;

import edu.uiuc.edsg.Chain;
import edu.uiuc.edsg.CompositeGenerator;
import edu.uiuc.edsg.IGenerator;
import edu.uiuc.edsg.IIterationLink;
import edu.uiuc.edsg.LinkCreator;

public class StatementWithExpressionBuilderGenerator extends
		CompositeGenerator<StatementWithExpressionBuilder> {

	private Chain<StatementWithExpressionBuilder> builderGen;

	public StatementWithExpressionBuilderGenerator(StatementWithExpressionBuilder...builders) {
		this.builderGen = new Chain<StatementWithExpressionBuilder>(builders);
	}

	public static StatementWithExpressionBuilderGenerator allExpressionTypes() {
		return new StatementWithExpressionBuilderGenerator(StatementWithExpressionBuilder.allExpressionTypes());
	}
	
	@Override
	protected IIterationLink getInitializedIterator() {
		return LinkCreator.createCombinatoricLink(builderGen);
	}

	@Override
	protected StatementWithExpressionBuilder generateCurrent() {
		return builderGen.current();
	}

}
