package edu.uiuc.astgen.test.basic;

import org.eclipse.jdt.core.dom.PrimitiveType;
import org.junit.Test;

import edu.uiuc.astgen.basic.ConstructorInvocationGenerator;
import edu.uiuc.astgen.basic.NumberLiteralGenerator;
import edu.uiuc.astgen.basic.StringLiteralGenerator;
import edu.uiuc.astgen.basic.SwitchCaseGenerator;
import edu.uiuc.edsg.test.GeneratorTestUtil;

public class ConstructorInvocationGeneratorTest {
	@Test
	public void DefaultConstructorInvocation() {		
		GeneratorTestUtil.testBasicFunctionality(ConstructorInvocationGenerator.getNewDefaultConstructorInvocationGenerator(), 2);
	}
	
	@Test
	public void SimpleConstructorInvocation() {		
		NumberLiteralGenerator numberGen = new NumberLiteralGenerator(3, PrimitiveType.BYTE);
		StringLiteralGenerator stringGen = StringLiteralGenerator.getNewDefaultStringLiteralGenerator();
		ConstructorInvocationGenerator constructorInvocationGen = new ConstructorInvocationGenerator();	
		constructorInvocationGen.addArgumentGenerator(numberGen);
		constructorInvocationGen.addArgumentGenerator(stringGen);
		GeneratorTestUtil.testBasicFunctionality(constructorInvocationGen, 6);
	}	
}
