package edu.uiuc.astgen.test.basic;

import org.eclipse.jdt.core.dom.AST;
import org.eclipse.jdt.core.dom.Modifier;
import org.eclipse.jdt.core.dom.PrimitiveType;
import org.junit.Test;

import edu.uiuc.astgen.basic.ModifierGenerator;
import edu.uiuc.astgen.basic.PrimitiveTypeGenerator;
import edu.uiuc.astgen.basic.SimpleNameGenerator;
import edu.uiuc.astgen.basic.SingleVariableDeclarationGenerator;
import edu.uiuc.astgen.basic.VariableDeclarationExpressionGenerator;
import edu.uiuc.astgen.test.ASTNodeGeneratorTestUtil;
import edu.uiuc.edsg.test.GeneratorTestUtil;

public class VariableDeclarationExpressionGeneratorTest {
	@Test
	public void testBasicFunctionality() {
		AST ast = ASTNodeGeneratorTestUtil.getSampleAST();
		SimpleNameGenerator nameGen = new SimpleNameGenerator("theVariable");
		PrimitiveTypeGenerator typeGen = new PrimitiveTypeGenerator(PrimitiveType.BOOLEAN, 
				PrimitiveType.BYTE);
		ModifierGenerator modGen = new ModifierGenerator((Modifier.ModifierKeyword)null,
				Modifier.ModifierKeyword.FINAL_KEYWORD);		
		
		VariableDeclarationExpressionGenerator svdg = new VariableDeclarationExpressionGenerator(nameGen, 
				typeGen, 
				modGen);
		
		GeneratorTestUtil.testBasicFunctionality(svdg, 1 * 2 * 2);
	}
}
